#!/usr/bin/python
import sys
import collections

from tabulate import tabulate
try:
    import xml.etree.cElementTree as ET
except ImportError:
    import xml.etree.ElementTree as ET

results = dict()
elements_done=0
fname = sys.argv[1]
for action,elem in ET.iterparse(sys.argv[1]):
    if elem.tag == 'AuditRecord':
        if (elem.find('OS_User').tag == 'OS_User' and elem.find('OS_User').text != 'SYSTEM' and elem.find('OS_User').text != 'tomcat' and elem.find('OS_User').text != 'dsadm' and elem.find('OS_User').text != 'rdsdb' and elem.find('OS_User').text != 'rdshm' and elem.find('OS_User').text != 'pscs' and elem.find('OS_User').text != 'dbmanager' and elem.find('OS_User').text != 'root'):
            if elem.find('OS_User') != None:
                osuser = elem.find('OS_User').text
            else:
                osuser = 'Unknown'
            if elem.find('Object_Name') != None:
                obj = elem.find('Object_Name').text
            else:
                obj = 'Unknown'
            if elem.find('DB_User') != None:
                usr = elem.find('DB_User').text
            else:
                usr = 'Unknown'
            key=osuser + obj + usr
            if not key in results:
                results[key] = {'name': osuser, 'object': obj,'dbuser': usr, 'updcnt':0, 'delcnt':0, 'altcnt':0, 'inscnt':0, 'grtcnt':0, 'drpcnt':0, 'trcnt':0}
            record = results[key]
            if ((elem.find('SesActions') != None and elem.find('SesActions').tag  == 'SesActions' and elem.find('SesActions').text == 'S---------------') or (elem.find('Action') != None and elem.find('Action').tag  == 'Action' and  elem.find('Action').text == '15')):
                oname = elem.find('Object_Name').text
                record['altcnt']  += 1
            if ((elem.find('SesActions') != None and elem.find('SesActions').tag  == 'SesActions' and elem.find('SesActions').text == '---S------------') or (elem.find('Action') != None and elem.find('Action').tag  == 'Action' and  elem.find('Action').text == '7')):
                oname = elem.find('Object_Name').text
                record['delcnt']  += 1
            if ((elem.find('SesActions') != None and elem.find('SesActions').tag  == 'SesActions' and elem.find('SesActions').text == '----------S-----') or (elem.find('Action') != None and elem.find('Action').tag  == 'Action' and  elem.find('Action').text == '6')):
                oname = elem.find('Object_Name').text
                record['updcnt']  += 1
            if ((elem.find('SesActions') != None and elem.find('SesActions').tag  == 'SesActions' and elem.find('SesActions').text == '------S---------') or (elem.find('Action') != None and elem.find('Action').tag  == 'Action' and  elem.find('Action').text == '2')):
                oname = elem.find('Object_Name').text
                record['inscnt']  += 1
            if elem.find('Action') != None and elem.find('Action').tag  == 'Action' and  elem.find('Action').text == '17':
                oname = elem.find('Object_Name').text
                record['grtcnt']  += 1
            if elem.find('Action') != None and elem.find('Action').tag  == 'Action' and  elem.find('Action').text == '12':
                oname = elem.find('Object_Name').text
                record['drpcnt']  += 1
            if elem.find('Action') != None and elem.find('Action').tag  == 'Action' and  elem.find('Action').text == '85':
                oname = elem.find('Object_Name').text
                record['trcnt']  += 1


            elements_done += 1

header_row = '''
User           \tSchema Name                    \tObject                \tINSERTS\tDELETES\tUPDATES\tALTER  \tGRANTS \tDROPS \tTRUNCATE
-------------- \t-------------------------------\t-----------------------       \t-------\t-------\t-------\t-------\t-------\t-------\t--------'''
output_line = '%-15.15s\t%-30.30s\t%-30.30s\t%7d\t%7d\t%7d\t%7d\t%7d\t%7d\t%7d'
current_user = ''
row_count = 0
page_size = 100
for key in collections.OrderedDict(sorted(results.items())):
    record = results[key]
    if current_user != record['name']:
        name = record['name']
        current_user = record['name']
    if (row_count % page_size) == 0:
        name = record['name']
        print
        print header_row
    print output_line%(name, record['dbuser'], record['object'], record['inscnt'], record['delcnt'], record['updcnt'], record['altcnt'], record['grtcnt'], record['drpcnt'], record['trcnt'])
    row_count += 1
    name=''



